<template>
  <v-card
      elevation="0"
      min-width="300"
      width="100%"
      max-width="500"
    >
    <h2 class="mb-6">User Info</h2>
    <v-card-text>
      <p>First name: {{ userInfo.first_name }}</p>
      <p>Last name: {{ userInfo.last_name }}</p>
      <p>Account status: {{ userInfo.account_status?"open":"lock" }}</p>
      <p>Email: {{ userInfo.email }}</p>
      <p>Username: {{ userInfo.username }}</p>
      <p class="red--text">Time: {{ getHours }} hours {{ getMinutes }} minutes</p>
    </v-card-text>
  </v-card>
</template>

<script>
import { mapActions } from 'vuex'

export default {
  name: "UserInfo",
  data() {
    return {
      userInfo: {}
    }
  },
  computed: {
    getHours() {
      return Math.floor( this.userInfo.time / 60)
    },
    getMinutes() {
      return Math.round((( this.userInfo.time / 60) - this.getHours) * 60).toLocaleString('en-US', {
        minimumIntegerDigits: 2
      })
    }
  },
  created() {
    this.fetchUserInfo()
    this.$eventBus.$on('updateUser', this.updateUserHandler)
  },
  methods: {
    ...mapActions(['setUserInfo']),
    async fetchUserInfo() {
      try {
        const response = await this.$axios.get('/api/getUser')

        if(response.status === 200) {
          this.userInfo = response.data
          this.setUserInfo({
            //TODO use userInfo.time ?
            username: this.userInfo.username,
            userId: this.userInfo.user_id,
            cardNumber: this.userInfo.cardNumber,
            currentTime: this.userInfo.time,
            balance: this.userInfo.balance
          })
        }
      } catch (error) {
        console.log(error)
      }
    },
    updateUserHandler(updatedUserInfo) {
      this.userInfo = updatedUserInfo
    }
  }
}
</script>

<style scoped>

</style>
